﻿using Prism.Ioc;
using Prism.Regions;
using System.Windows;
using Txgy.FilesWatcher.Views;

namespace Txgy.FilesWatcher
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App
    {
        protected override Window CreateShell()
        {
            return Container.Resolve<MainWindow>();
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterSingleton<WebsocketClient>();



            var iregion= Container.Resolve<IRegionManager>();
            iregion.RegisterViewWithRegion("MainContentRegion", typeof(MainView)); 
        }


    }
}
