﻿using SuperSocket.ClientEngine;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading;
using System.Threading.Tasks;
using Txgy.FilesWatcher.model;
using WebSocket4Net;

namespace Txgy.FilesWatcher
{
    public class WebsocketClient
    {
        public WebSocket webSocket4Net = null;

        public Action<ErrorEventArgs> WebsocketError;
        public Action<string> WebSocketMessageReceived;
        public void WebSocketInit(string url)
        {
            Debug.WriteLine("客户端");
            webSocket4Net = new WebSocket(url);
            webSocket4Net.Opened += WebSocket4Net_Opened;
            webSocket4Net.Error += new EventHandler<ErrorEventArgs>(WebSocket_Error);
            webSocket4Net.MessageReceived += WebSocket4Net_MessageReceived;
            webSocket4Net.Open();
           
            Debug.WriteLine("客户端连接成功！");
            Thread thread = new Thread(SendHeartbeat);
            thread.IsBackground = true;
            thread.Start();
        }
        public void SiginServer(string account,string password)
        {
            string jsonstr= JsonSerializer.Serialize(new CSUserSigin { type = CSMessage.sigin, utpye = "device", account=account,password=password});
            SendMes(jsonstr);
        }


        public void SendMes(string message)
        {
            webSocket4Net.Send(message);
        }

        private void SendHeartbeat()
        {
            while (true)
            {
                //Console.WriteLine($"客户端发送数据{i++}");
                Thread.Sleep(TimeSpan.FromSeconds(1));
                if (webSocket4Net.State == WebSocketState.Open)
                {
                    webSocket4Net.Send("{\"type\":\"heartbeat\",\"utype\":\"device\",\"uid\":123}");
                }
                else if (webSocket4Net.State == WebSocketState.Closed)
                {
                    Thread.Sleep(TimeSpan.FromSeconds(10));
                    webSocket4Net.Open();
                }
            }
        }

        private void WebSocket4Net_MessageReceived(object sender, MessageReceivedEventArgs e)
        {
            WebSocketMessageReceived?.Invoke(e.Message);
            Debug.WriteLine($"服务端回复数据:{e.Message}！");
        }

        private void WebSocket4Net_Opened(object sender, EventArgs e)
        {
          
        }
        void WebSocket_Error(object sender, ErrorEventArgs e)
        {
            WebsocketError?.Invoke(e);
            Debug.WriteLine("websocket_Error:" + e.Exception.ToString());
        }
    }
}
